"enable aexpr";

System.register(['active-expression-rewriting', 'reactive-jsx', 'src/components/halo/lively-halo-item.js', 'src/client/graphics.js', 'src/client/contextmenu.js', './Connection.js', 'src/client/constants.js'], function (_export, _context) {
  "use strict";

  var _getAndCallMember, _setMember, _setLocal, _getLocal, _getGlobal, _getMember, _traceMember, _childExpression, _children, _attributes, _element, HaloItem, pt, ContextMenu, Connection, domEvents, cssProperties;

  return {
    setters: [function (_activeExpressionRewriting) {
      _getAndCallMember = _activeExpressionRewriting.getAndCallMember;
      _setMember = _activeExpressionRewriting.setMember;
      _setLocal = _activeExpressionRewriting.setLocal;
      _getLocal = _activeExpressionRewriting.getLocal;
      _getGlobal = _activeExpressionRewriting.getGlobal;
      _getMember = _activeExpressionRewriting.getMember;
      _traceMember = _activeExpressionRewriting.traceMember;
    }, function (_reactiveJsx) {
      _childExpression = _reactiveJsx.childExpression;
      _children = _reactiveJsx.children;
      _attributes = _reactiveJsx.attributes;
      _element = _reactiveJsx.element;
    }, function (_srcComponentsHaloLivelyHaloItemJs) {
      HaloItem = _srcComponentsHaloLivelyHaloItemJs.default;
    }, function (_srcClientGraphicsJs) {
      pt = _srcClientGraphicsJs.pt;
    }, function (_srcClientContextmenuJs) {
      ContextMenu = _srcClientContextmenuJs.default;
    }, function (_ConnectionJs) {
      Connection = _ConnectionJs.default;
    }, function (_srcClientConstantsJs) {
      domEvents = _srcClientConstantsJs.domEvents;
      cssProperties = _srcClientConstantsJs.cssProperties;
    }],
    execute: function () {
      const __SystemJSRewritingHack = {};
      _recorder_._src_components_halo_lively_halo_connectors_item_js = _recorder_._src_components_halo_lively_halo_connectors_item_js || {};
      let _scope = {};
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'HaloItem', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'HaloItem', HaloItem) : void 0, HaloItem;
        },

        set(thisIsVererySecretVariableName) {
          let _scope2 = {};
          HaloItem = (self.__expressionAnalysisMode__ ? _getLocal(_scope2, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'HaloItem', HaloItem) : void 0, HaloItem;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'pt', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'pt', pt) : void 0, pt;
        },

        set(thisIsVererySecretVariableName) {
          let _scope3 = {};
          pt = (self.__expressionAnalysisMode__ ? _getLocal(_scope3, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'pt', pt) : void 0, pt;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'ContextMenu', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'ContextMenu', ContextMenu) : void 0, ContextMenu;
        },

        set(thisIsVererySecretVariableName) {
          let _scope4 = {};
          ContextMenu = (self.__expressionAnalysisMode__ ? _getLocal(_scope4, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'ContextMenu', ContextMenu) : void 0, ContextMenu;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'Connection', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'Connection', Connection) : void 0, Connection;
        },

        set(thisIsVererySecretVariableName) {
          let _scope5 = {};
          Connection = (self.__expressionAnalysisMode__ ? _getLocal(_scope5, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'Connection', Connection) : void 0, Connection;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'cssProperties', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'cssProperties', cssProperties) : void 0, cssProperties;
        },

        set(thisIsVererySecretVariableName) {
          let _scope6 = {};
          cssProperties = (self.__expressionAnalysisMode__ ? _getLocal(_scope6, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'cssProperties', cssProperties) : void 0, cssProperties;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'domEvents', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'domEvents', domEvents) : void 0, domEvents;
        },

        set(thisIsVererySecretVariableName) {
          let _scope7 = {};
          domEvents = (self.__expressionAnalysisMode__ ? _getLocal(_scope7, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'domEvents', domEvents) : void 0, domEvents;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      class LivelyHaloConnectorsItem extends HaloItem {

        async initialize() {
          _setMember(this, 'windowTitle', "LivelyHaloConnectorsItem");

          if (self.__expressionAnalysisMode__) _traceMember(this, 'registerEvent');
          this.registerEvent('click', 'onClick');
        }

        onClick(evt) {
          let _scope8 = {};

          _setMember(this, 'source', _getMember((self.__expressionAnalysisMode__ ? _getGlobal('window') : void 0, window), 'that'));

          if (self.__expressionAnalysisMode__) _traceMember(this, 'showStartingConnectorsMenuFor');
          this.showStartingConnectorsMenuFor((self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt));

          if (self.__expressionAnalysisMode__) _traceMember(this, 'hideHalo');
          this.hideHalo();
        }

        attachedCallback() {}

        detachedCallback() {}

        async showMenu(evt, menuItems) {
          let _scope9 = {};

          return self.__expressionAnalysisMode__ ? _traceMember(ContextMenu, 'openIn') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'ContextMenu', ContextMenu) : void 0, ContextMenu).openIn(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), (self.__expressionAnalysisMode__ ? _getLocal(_scope9, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getGlobal('undefined') : void 0, undefined), _getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), (self.__expressionAnalysisMode__ ? _getLocal(_scope9, 'menuItems', menuItems) : void 0, menuItems));
        }

        async showStartingConnectorsMenuFor(evt) {
          let _scope11 = {};


          let myConnectionsMenu = _getAndCallMember((self.__expressionAnalysisMode__ ? _traceMember(Connection, 'allConnectionsFor') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'Connection', Connection) : void 0, Connection).allConnectionsFor(_getMember(this, 'source'))), 'map', [connection => {
            let _scope10 = {};
            return [(self.__expressionAnalysisMode__ ? _traceMember(connection, 'getLabel') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope10, 'connection', connection) : void 0, connection).getLabel()), () => {
              return self.__expressionAnalysisMode__ ? _traceMember(this, 'openConnectionEditor') : void 0, this.openConnectionEditor((self.__expressionAnalysisMode__ ? _getLocal(_scope10, 'connection', connection) : void 0, connection));
            }];
          }]);

          const menuItems = [['Value', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'evt', evt) : void 0, evt), 'value', false);
          }], ['Width', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'evt', evt) : void 0, evt), 'style.width', false);
          }], ['Height', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'evt', evt) : void 0, evt), 'style.height', false);
          }], ['Events', (self.__expressionAnalysisMode__ ? _traceMember(this, 'getAllEventsFor') : void 0, this.getAllEventsFor(_getMember(this, 'source'), (self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'evt', evt) : void 0, evt)))], ['Style', (self.__expressionAnalysisMode__ ? _traceMember(this, 'getAllStylesFor') : void 0, this.getAllStylesFor(_getMember(this, 'source'), (self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'evt', evt) : void 0, evt)))], ['On custom...', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionCustom') : void 0, this.startCreatingConnectionCustom((self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'evt', evt) : void 0, evt));
          }], ['Connections', (self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'myConnectionsMenu', myConnectionsMenu) : void 0, myConnectionsMenu), '', '<i class="fa fa-arrow-right" aria-hidden="true"></i>']];

          return self.__expressionAnalysisMode__ ? _traceMember(this, 'showMenu') : void 0, this.showMenu((self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'menuItems', menuItems) : void 0, menuItems));
        }

        //More events https://developer.mozilla.org/en-US/docs/Web/Events
        getAllEventsFor(object, evt) {
          let _scope13 = {};

          const allEvents = (self.__expressionAnalysisMode__ ? _traceMember(domEvents, 'map') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'domEvents', domEvents) : void 0, domEvents).map(domEvent => {
            let _scope12 = {};
            return [(self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'domEvent', domEvent) : void 0, domEvent), () => {
              return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'domEvent', domEvent) : void 0, domEvent), true);
            }];
          }));

          return [['click', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'evt', evt) : void 0, evt), 'click', true);
          }], ['dblclick', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'evt', evt) : void 0, evt), 'dblclick', true);
          }], ['mousemove', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'evt', evt) : void 0, evt), 'mousemove', true);
          }], ['more', (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'allEvents', allEvents) : void 0, allEvents)]];
        }

        getAllStylesFor(object, evt, isFinishing = false) {
          let _scope14 = {};

          const result = [];

          if (self.__expressionAnalysisMode__) _traceMember(cssProperties, 'forEach');
          (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'cssProperties', cssProperties) : void 0, cssProperties).forEach(cssProperty => {
            let _scope15 = {};

            if (self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'isFinishing', isFinishing) : void 0, isFinishing) {
              if (self.__expressionAnalysisMode__) _traceMember(result, 'push');

              (self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'result', result) : void 0, result).push([(self.__expressionAnalysisMode__ ? _getLocal(_scope15, 'cssProperty', cssProperty) : void 0, cssProperty), event => {
                let _scope16 = {};
                return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'object', object) : void 0, object), 'style.' + (self.__expressionAnalysisMode__ ? _getLocal(_scope15, 'cssProperty', cssProperty) : void 0, cssProperty), (self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'event', event) : void 0, event));
              }]);
            } else {
              if (self.__expressionAnalysisMode__) _traceMember(result, 'push');

              (self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'result', result) : void 0, result).push([(self.__expressionAnalysisMode__ ? _getLocal(_scope15, 'cssProperty', cssProperty) : void 0, cssProperty), () => {
                return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'evt', evt) : void 0, evt), 'style.' + (self.__expressionAnalysisMode__ ? _getLocal(_scope15, 'cssProperty', cssProperty) : void 0, cssProperty), false);
              }]);
            }
          });

          return self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'result', result) : void 0, result;
        }

        async showFinishingConnectorsMenuFor(evt, morph) {
          let _scope17 = {};

          const menuItems = [['Value', event => {
            let _scope18 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'morph', morph) : void 0, morph), 'value', (self.__expressionAnalysisMode__ ? _getLocal(_scope18, 'event', event) : void 0, event));
          }], ['Width', event => {
            let _scope19 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'morph', morph) : void 0, morph), 'style.width', (self.__expressionAnalysisMode__ ? _getLocal(_scope19, 'event', event) : void 0, event));
          }], ['Height', event => {
            let _scope20 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'morph', morph) : void 0, morph), 'style.height', (self.__expressionAnalysisMode__ ? _getLocal(_scope20, 'event', event) : void 0, event));
          }], ['innerHTML', event => {
            let _scope21 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'morph', morph) : void 0, morph), 'innerHTML', (self.__expressionAnalysisMode__ ? _getLocal(_scope21, 'event', event) : void 0, event));
          }],
          // Hook for chained events
          //['Events', this.getAllEventsFor(morph, evt, true)],
          ['Style', (self.__expressionAnalysisMode__ ? _traceMember(this, 'getAllStylesFor') : void 0, this.getAllStylesFor((self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'morph', morph) : void 0, morph), (self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'evt', evt) : void 0, evt), true))], ['On custom...', event => {
            let _scope22 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnectionCustom') : void 0, this.finishCreatingConnectionCustom((self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'morph', morph) : void 0, morph), (self.__expressionAnalysisMode__ ? _getLocal(_scope22, 'event', event) : void 0, event));
          }]];
          return await (self.__expressionAnalysisMode__ ? _traceMember(this, 'showMenu') : void 0, this.showMenu((self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'menuItems', menuItems) : void 0, menuItems)));
        }

        elementUnderHand(evt) {
          let _scope23 = {};

          return _getAndCallMember(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively), 'hand'), 'elementUnderHand', [(self.__expressionAnalysisMode__ ? _getLocal(_scope23, 'evt', evt) : void 0, evt)]);
        }

        onPointerMove(evt) {
          let _scope24 = {};

          if (_getMember(this, 'dropIndicator')) {
            _getAndCallMember(_getMember(this, 'dropIndicator'), 'remove', []);
          }_setMember(this, 'dropTarget', (self.__expressionAnalysisMode__ ? _traceMember(this, 'elementUnderHand') : void 0, this.elementUnderHand((self.__expressionAnalysisMode__ ? _getLocal(_scope24, 'evt', evt) : void 0, evt))));
          if (_getMember(this, 'dropTarget')) {
            _setMember(this, 'dropIndicator', (self.__expressionAnalysisMode__ ? _traceMember(lively, 'showElement') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).showElement(_getMember(this, 'dropTarget'))));
            _setMember(_getMember(_getMember(this, 'dropIndicator'), 'style'), 'border', "3px dashed rgba(0,100,0,0.5)");
            _setMember(_getMember(this, 'dropIndicator'), 'innerHTML', "");
          }

          if (_getMember(this, 'valueIndicator')) {
            _getAndCallMember(_getMember(this, 'valueIndicator'), 'remove', []);
          }
          _setMember(this, 'valueIndicator', _element('span', _attributes(), _children(_childExpression(_getMember(this, 'sourceProperty'))), {
            file: 'https://lively-kernel.org/lively4/lively4-leo/src/components/halo/lively-halo-connectors-item.js',
            end: {
              column: 60,
              line: 112
            },
            start: {
              column: 26,
              line: 112
            }
          }));
          _setMember(_getMember(this, 'valueIndicator'), 'isMetaNode', true);
          _setMember(_getMember(_getMember(this, 'valueIndicator'), 'style'), 'zIndex', 200);
          _getAndCallMember(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), 'appendChild', [_getMember(this, 'valueIndicator')]);
          if (self.__expressionAnalysisMode__) _traceMember(lively, 'setGlobalPosition');
          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).setGlobalPosition(_getMember(this, 'valueIndicator'), (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'pt', pt) : void 0, pt)(_getMember((self.__expressionAnalysisMode__ ? _traceMember(lively, 'getPosition') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).getPosition((self.__expressionAnalysisMode__ ? _getLocal(_scope24, 'evt', evt) : void 0, evt))), 'x') + 1, _getMember((self.__expressionAnalysisMode__ ? _traceMember(lively, 'getPosition') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).getPosition((self.__expressionAnalysisMode__ ? _getLocal(_scope24, 'evt', evt) : void 0, evt))), 'y') + 1));
        }

        onPointerUp(evt) {
          let _scope25 = {};
          if (self.__expressionAnalysisMode__) _traceMember(lively, 'removeEventListener');

          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).removeEventListener("Connectors");

          if (_getMember(this, 'dropIndicator')) {
            _getAndCallMember(_getMember(this, 'dropIndicator'), 'remove', []);
          }if (_getMember(this, 'valueIndicator')) {
            _getAndCallMember(_getMember(this, 'valueIndicator'), 'remove', []);
          }var morph = (self.__expressionAnalysisMode__ ? _traceMember(this, 'elementUnderHand') : void 0, this.elementUnderHand((self.__expressionAnalysisMode__ ? _getLocal(_scope25, 'evt', evt) : void 0, evt)));

          if (self.__expressionAnalysisMode__) _traceMember(this, 'showFinishingConnectorsMenuFor');
          this.showFinishingConnectorsMenuFor((self.__expressionAnalysisMode__ ? _getLocal(_scope25, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope25, 'morph', morph) : void 0, morph));
        }

        async openConnectionEditor(connection) {
          let _scope26 = {};

          let editor = await (self.__expressionAnalysisMode__ ? _traceMember(lively, 'openComponentInWindow') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).openComponentInWindow('lively-connection-editor'));
          if (self.__expressionAnalysisMode__) _traceMember(lively, 'setExtent');
          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).setExtent(_getMember((self.__expressionAnalysisMode__ ? _getLocal(_scope26, 'editor', editor) : void 0, editor), 'parentElement'), (self.__expressionAnalysisMode__ ? _traceMember(lively, 'pt') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).pt(800, 50)));
          if (self.__expressionAnalysisMode__) _traceMember(editor, 'setConnection');
          (self.__expressionAnalysisMode__ ? _getLocal(_scope26, 'editor', editor) : void 0, editor).setConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope26, 'connection', connection) : void 0, connection));
        }

        async startCreatingConnectionCustom(evt) {
          let _scope27 = {};

          var userinput = await (self.__expressionAnalysisMode__ ? _traceMember(lively, 'prompt') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).prompt("Enter something", "value"));
          if (self.__expressionAnalysisMode__) _traceMember(this, 'startCreatingConnectionFor');
          this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope27, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope27, 'userinput', userinput) : void 0, userinput), false);
        }

        startCreatingConnectionFor(evt, property, isEvent) {
          let _scope28 = {};

          _setMember(this, 'sourceProperty', (self.__expressionAnalysisMode__ ? _getLocal(_scope28, 'property', property) : void 0, property));
          _setMember(this, 'isEvent', (self.__expressionAnalysisMode__ ? _getLocal(_scope28, 'isEvent', isEvent) : void 0, isEvent));

          if (self.__expressionAnalysisMode__) _traceMember(lively, 'addEventListener');
          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).addEventListener("Connectors", _getMember(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), 'parentElement'), "pointermove", e => {
            let _scope29 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'onPointerMove') : void 0, this.onPointerMove((self.__expressionAnalysisMode__ ? _getLocal(_scope29, 'e', e) : void 0, e));
          }, { capture: true });
          if (self.__expressionAnalysisMode__) _traceMember(lively, 'addEventListener');
          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).addEventListener("Connectors", _getMember(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), 'parentElement'), "pointerup", e => {
            let _scope30 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'onPointerUp') : void 0, this.onPointerUp((self.__expressionAnalysisMode__ ? _getLocal(_scope30, 'e', e) : void 0, e));
          }, { capture: true });
        }

        async finishCreatingConnectionCustom(target, event) {
          let _scope31 = {};

          var userinput = await (self.__expressionAnalysisMode__ ? _traceMember(lively, 'prompt') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).prompt("Enter something", "style.width"));
          if (self.__expressionAnalysisMode__) _traceMember(this, 'finishCreatingConnection');
          this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'target', target) : void 0, target), (self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'userinput', userinput) : void 0, userinput), (self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'event', event) : void 0, event));
        }

        finishCreatingConnection(target, targetProperty, event) {
          let _scope32 = {};

          let connection = new (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'Connection', Connection) : void 0, Connection)(_getMember(this, 'source'), _getMember(this, 'sourceProperty'), (self.__expressionAnalysisMode__ ? _getLocal(_scope32, 'target', target) : void 0, target), (self.__expressionAnalysisMode__ ? _getLocal(_scope32, 'targetProperty', targetProperty) : void 0, targetProperty), _getMember(this, 'isEvent'));
          if (self.__expressionAnalysisMode__) _traceMember(connection, 'activate');
          (self.__expressionAnalysisMode__ ? _getLocal(_scope32, 'connection', connection) : void 0, connection).activate();
          if (self.__expressionAnalysisMode__) _traceMember(connection, 'drawConnectionLine');
          (self.__expressionAnalysisMode__ ? _getLocal(_scope32, 'connection', connection) : void 0, connection).drawConnectionLine();
          if (!_getMember((self.__expressionAnalysisMode__ ? _getLocal(_scope32, 'event', event) : void 0, event), 'shiftKey')) {
            if (self.__expressionAnalysisMode__) _traceMember(this, 'openConnectionEditor');

            this.openConnectionEditor((self.__expressionAnalysisMode__ ? _getLocal(_scope32, 'connection', connection) : void 0, connection));
          }
        }
      }

      _export('default', LivelyHaloConnectorsItem);

      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'LivelyHaloConnectorsItem', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'LivelyHaloConnectorsItem', LivelyHaloConnectorsItem) : void 0, LivelyHaloConnectorsItem;
        },

        set(thisIsVererySecretVariableName) {
          let _scope33 = {};
          _export('default', LivelyHaloConnectorsItem = (self.__expressionAnalysisMode__ ? _getLocal(_scope33, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName)), true ? _setLocal(_scope, 'LivelyHaloConnectorsItem', LivelyHaloConnectorsItem) : void 0, LivelyHaloConnectorsItem;
          return true;
        },

        enumerable: true,
        configurable: true
      });
    }
  };
});